// ps1.cpp : Defines the entry point for the console application.
//

#ifdef _CH_
#pragma	package	<opencv>
#endif

#ifndef	_EiC
#include "cv.h"
#include "highgui.h"
#include <stdio.h>
#include <ctype.h>
#endif

IplImage *image	= 0, *hsv =	0, *hue	= 0, *mask = 0,	*backproject = 0;
char filename[16];
int	 imageNum;

int	bCheckImageOkay(IplImage *img);

int	main(int argc, char* argv[])
{
	CvCapture* capture = 0;
	
	if(	argc ==	1 || (argc == 2	&& strlen(argv[1]) == 1	&& isdigit(argv[1][0])))
		capture	= cvCaptureFromCAM(	argc ==	2 ?	argv[1][0] - '0' : 0 );
	else if( argc == 2 )
		capture	= cvCaptureFromAVI(	argv[1]	); 

	if(	!capture )
	{
		fprintf(stderr,"Could not initialize capturing...\n");
		return -1;
	}

	printf(	"Hot keys: \n"
		"\tESC - quit the program\n"
		"\tc - capture image\n"	);

	cvNamedWindow("Camera Stream", 1 );
	
	//set up base file name	
	strcat(filename, "imagexx.bmp");

	imageNum = 0;
	for(;;)
	{
		IplImage* frame	= 0;
		int	c;

		frame =	cvQueryFrame( capture );
		if(	!frame )
			break;

		if(	!image )
		{
			/* allocate	all	the	buffers	*/
			image =	cvCreateImage( cvGetSize(frame), 8,	3 );
			image->origin =	frame->origin;
			hsv	= cvCreateImage( cvGetSize(frame), 8, 3	);
			hue	= cvCreateImage( cvGetSize(frame), 8, 1	);
			mask = cvCreateImage( cvGetSize(frame),	8, 1 );
			backproject	= cvCreateImage( cvGetSize(frame), 8, 1	);
		}

		cvCopy(	frame, image, 0	);
		cvCvtColor(	image, hsv,	CV_BGR2HSV );
		
		cvShowImage( "Camera Stream", image	);
	 
		c =	cvWaitKey(10);
		if(	c == 27	)
			break;
		switch(	c )
		{
		case 'c':
		
		if (bCheckImageOkay(image)){
			filename[5]	= (char)((imageNum / 10) + 48);
			filename[6]	= (char)((imageNum % 10) + 48);
			imageNum++;
			cvSaveImage(filename, image);
		}
		break;
		default: break;
		}
	}

	cvReleaseCapture( &capture );
	cvDestroyWindow("Camera	Stream");

	return 0;
}

int	bCheckImageOkay(IplImage *img)
{
	CvPoint2D32f *cornersArray = 0;

	//create images
	IplImage *bw		= cvCreateImage(cvSize(img->width, img->height), IPL_DEPTH_8U, 1);
	IplImage *threshold	= cvCreateImage(cvSize(img->width, img->height), IPL_DEPTH_8U, 1);
	cvConvertImage(img,	bw);

	//find chessboard varables
	int	allfound = 49; 
	CvPoint2D32f *corners = new CvPoint2D32f[49];


	int	toReturn = cvFindChessBoardCornerGuesses(bw, threshold,	NULL, cvSize(7,	7),	corners, &allfound);

	//destroy structures
	cvReleaseImage(&bw);
	cvReleaseImage(&threshold);

	//destroy variables
	delete corners;

	return toReturn;
}

